import { Injectable, Component, ViewContainerRef, Injector, ViewChild, EventEmitter, Input, Output, ComponentFactoryResolver, ApplicationRef, ɵɵdefineInjectable, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { Subject } from 'rxjs';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/m-dynamic-dialog-services/m-dynamic-dialog-data.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MDynamicDialogData {
    constructor() { }
}
MDynamicDialogData.decorators = [
    { type: Injectable }
];
/** @nocollapse */
MDynamicDialogData.ctorParameters = () => [];
if (false) {
    /** @type {?} */
    MDynamicDialogData.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/m-dynamic-dialog-services/m-dynamic-dialog-reference.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MDynamicDialogReference {
    constructor() {
        this.onSave = new Subject();
        this.onClose = new Subject();
        this.saveButtonEnabled = true;
        this.closeButtonEnabled = true;
        /** @type {?} */
        var date = new Date();
        this.dialogId = "dialog-" + date.getHours() + date.getMinutes() + date.getSeconds() + date.getMilliseconds();
        this.listenForCloseDialog();
    }
    /**
     * @param {?=} data
     * @return {?}
     */
    save(data) {
        this.onSave.next(data);
        this.onClose.next(data);
    }
    /**
     * @param {?=} data
     * @return {?}
     */
    close(data) {
        this.onClose.next(data);
    }
    /**
     * @private
     * @return {?}
     */
    listenForCloseDialog() {
        this.onClose.subscribe((/**
         * @param {?} res
         * @return {?}
         */
        res => {
            console.log("removing");
            /** @type {?} */
            let dialog = document.getElementById(this.dialogId);
            document.getElementById("m-dynamic-dialog-container").removeChild(dialog);
        }));
    }
}
MDynamicDialogReference.decorators = [
    { type: Injectable }
];
/** @nocollapse */
MDynamicDialogReference.ctorParameters = () => [];
if (false) {
    /** @type {?} */
    MDynamicDialogReference.prototype.onSave;
    /** @type {?} */
    MDynamicDialogReference.prototype.onClose;
    /** @type {?} */
    MDynamicDialogReference.prototype.dialogId;
    /** @type {?} */
    MDynamicDialogReference.prototype.saveButtonEnabled;
    /** @type {?} */
    MDynamicDialogReference.prototype.closeButtonEnabled;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/m-dynamic-dialog/m-dynamic-dialog-body/m-dynamic-dialog-body.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MDynamicDialogBodyComponent {
    /**
     * @param {?} viewContainerRef
     */
    constructor(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
MDynamicDialogBodyComponent.decorators = [
    { type: Component, args: [{
                selector: 'm-dynamic-dialog-body',
                template: "",
                styles: [""]
            }] }
];
/** @nocollapse */
MDynamicDialogBodyComponent.ctorParameters = () => [
    { type: ViewContainerRef }
];
if (false) {
    /** @type {?} */
    MDynamicDialogBodyComponent.prototype.viewContainerRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/m-dynamic-dialog/m-dynamic-dialog.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MDynamicDialogComponent {
    /**
     * @param {?} mDynamicDialogReference
     */
    constructor(mDynamicDialogReference) {
        this.mDynamicDialogReference = mDynamicDialogReference;
        this.headerHeight = "7vh";
        this.footerHeight = "5vh";
        this.bodyHeight = "";
        this.loaded = false;
        this.id = "";
        this.componentFactoryResolver = null;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.calculateDialogPropertiesAndSet(this.parameter.Properties);
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.createComponent(this.componentFactoryResolver);
    }
    /**
     * @param {?} cfr
     * @return {?}
     */
    setComponentBuilders(cfr) {
        this.componentFactoryResolver = cfr;
    }
    /**
     * @template THIS
     * @this {THIS}
     * @param {?} properties
     * @return {THIS}
     */
    calculateDialogPropertiesAndSet(properties) {
        if (properties.headerHeight) {
            (/** @type {?} */ (this)).headerHeight = properties.headerHeight;
        }
        if (properties.footerHeight) {
            (/** @type {?} */ (this)).footerHeight = properties.footerHeight;
        }
        //console.log(properties);
        if (properties.showHeader === true)
            (/** @type {?} */ (this)).headerHeight = "0";
        if (properties.showFooter === true)
            (/** @type {?} */ (this)).footerHeight = "0";
        (/** @type {?} */ (this)).bodyHeight = properties.height;
        (/** @type {?} */ (this)).loaded = true;
        return (/** @type {?} */ (this));
    }
    /**
     * @param {?} cfr
     * @return {?}
     */
    createComponent(cfr) {
        /** @type {?} */
        const injector = Injector.create({
            providers: [
                {
                    provide: MDynamicDialogReference,
                    useValue: this.mDynamicDialogReference
                },
                {
                    provide: MDynamicDialogData,
                    useValue: this.mDynamicDialogData
                }
            ]
        });
        /** @type {?} */
        var dynamicComponent = cfr.resolveComponentFactory(this.parameter.Component);
        this.content.viewContainerRef.createComponent(dynamicComponent, 0, injector);
    }
    /**
     * @return {?}
     */
    saveButtonEnabled() {
        console.log(this.mDynamicDialogReference.saveButtonEnabled);
        return this.mDynamicDialogReference.saveButtonEnabled;
    }
    /**
     * @return {?}
     */
    closeButtonEnabled() {
        return this.mDynamicDialogReference.closeButtonEnabled;
    }
    /**
     * @return {?}
     */
    save() {
        this.mDynamicDialogReference.save();
    }
    /**
     * @return {?}
     */
    close() {
        this.mDynamicDialogReference.close();
    }
    /**
     * @return {?}
     */
    outsideClickClose() {
        this.mDynamicDialogReference.close();
    }
}
MDynamicDialogComponent.decorators = [
    { type: Component, args: [{
                selector: 'm-dynamic',
                template: "<div class=\"m-dynamic-dialog-environment\" [ngClass]=\"{'m-dynamic-modal-background': parameter.Properties?.asModal !== false}\">\n    <div *ngIf=\"loaded\" class=\"m-dynamic-dialog-container m-dynamic-card m-dynamic-no-padding\"\n        [ngStyle]=\"{'min-width': parameter.Properties?.width, 'max-width': parameter.Properties?.width}\">\n        <div *ngIf=\"parameter.Properties?.showHeader !== false\" class=\"m-dynamic-header m-dynamic-min-padding\" [ngStyle]=\"{\n                'max-height': headerHeight , \n                'max-width': parameter.Properties?.width, \n                'min-width': parameter.Properties?.width \n            }\">\n            <div class=\"m-dynamic-title\">\n                {{ parameter.Properties?.title }}\n            </div>\n            <span (click)=\"close()\">\n                <i class=\"fas fa-times m-dynamic-pointer m-dynamic-header-close\"></i>\n            </span>\n        </div>\n\n        <div class=\"m-dynamic-body\" [ngStyle]=\"{\n                'min-height': bodyHeight ? bodyHeight : '100%', \n                'max-height': bodyHeight ? bodyHeight : '100%', \n                'max-width': parameter.Properties?.width ? parameter.Properties?.width : '100%', \n                'min-width': parameter.Properties?.width ? parameter.Properties?.width : '100%'\n            }\">\n            <m-dynamic-dialog-body #content></m-dynamic-dialog-body>\n        </div>\n\n        <div *ngIf=\"parameter.Properties?.showFooter !== false\" class=\"m-dynamic-footer m-dynamic-min-padding\" [ngStyle]=\"{\n                'max-height': footerHeight, \n                'max-width': parameter.Properties?.width, \n                'min-width': parameter.Properties?.width\n            }\">\n            <div class=\"min-padding\" *ngIf=\"parameter.Properties?.showCloseButton !== false\">\n                <m-button\n                    [disabled]=\"closeButtonEnabled()\"\n                    label=\"{{ parameter.Properties?.closeButtonLabel ? parameter.Properties?.closeButtonLabel : 'Cancel' }}\"\n                    (onClick)=\"close()\"></m-button>\n            </div>\n            <div class=\"min-padding\" *ngIf=\"parameter.Properties?.showSaveButton !== false\">\n                <m-button\n                    [disabled]=\"saveButtonEnabled()\"\n                    label=\"{{ parameter.Properties?.saveButtonLabel ?parameter.Properties?.saveButtonLabel : 'Save' }}\"\n                    (onClick)=\"save()\">\n                </m-button>\n            </div>\n        </div>\n\n    </div>\n</div>",
                styles: [".m-dynamic-dialog-environment{height:100%!important;width:100%!important;z-index:1000000000!important;position:absolute!important;display:-webkit-box!important;display:flex!important;-webkit-box-pack:center!important;justify-content:center!important;-webkit-box-align:center!important;align-items:center!important;overflow:hidden!important;top:0!important;left:0!important;right:0!important;bottom:0!important}.m-dynamic-dialog-wrapper{height:100%;width:100%}.m-dynamic-modal-background{background:rgba(0,0,0,.5)}.m-dynamic-dialog-container{border:0!important;box-shadow:0 12px 15px 0 rgba(0,0,0,.25)}.m-dynamic-header{display:-webkit-box;display:flex;-webkit-box-pack:justify;justify-content:space-between;-webkit-box-align:center;align-items:center;box-sizing:border-box!important}.m-dynamic-title{font-size:1.5em}.m-dynamic-header-close{font-size:1.1em}.m-dynamic-body{padding:1vh;overflow-y:auto;box-sizing:border-box!important}.m-dynamic-footer{display:-webkit-box;display:flex;-webkit-box-pack:end;justify-content:flex-end;-webkit-box-align:center;align-items:center;box-shadow:0 0 1em rgba(0,0,0,.16);box-sizing:border-box!important}.m-dynamic-card{background:#fff!important;border-radius:2px!important;display:inline-block!important;position:relative!important;box-shadow:0 19px 38px rgba(0,0,0,.3),0 15px 12px rgba(0,0,0,.22)!important}.m-dynamic-min-padding{padding:1vh!important}.m-dynamic-pointer{cursor:pointer}.m-dynamic-no-padding{padding:0}::-webkit-scrollbar{width:.8em;border-radius:.5em}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888}::-webkit-scrollbar-thumb:hover{background:#555}"]
            }] }
];
/** @nocollapse */
MDynamicDialogComponent.ctorParameters = () => [
    { type: MDynamicDialogReference }
];
MDynamicDialogComponent.propDecorators = {
    content: [{ type: ViewChild, args: [MDynamicDialogBodyComponent, { static: false },] }]
};
if (false) {
    /** @type {?} */
    MDynamicDialogComponent.prototype.headerHeight;
    /** @type {?} */
    MDynamicDialogComponent.prototype.footerHeight;
    /** @type {?} */
    MDynamicDialogComponent.prototype.bodyHeight;
    /** @type {?} */
    MDynamicDialogComponent.prototype.loaded;
    /** @type {?} */
    MDynamicDialogComponent.prototype.parameter;
    /** @type {?} */
    MDynamicDialogComponent.prototype.id;
    /** @type {?} */
    MDynamicDialogComponent.prototype.mDynamicDialogData;
    /** @type {?} */
    MDynamicDialogComponent.prototype.componentFactoryResolver;
    /** @type {?} */
    MDynamicDialogComponent.prototype.content;
    /**
     * @type {?}
     * @private
     */
    MDynamicDialogComponent.prototype.mDynamicDialogReference;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/other-components/material-button/material-button.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MaterialButtonComponent {
    constructor() {
        this.disabled = false;
        this.onClick = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    onClickEmit() {
        if (!this.disabled)
            this.onClick.emit();
    }
}
MaterialButtonComponent.decorators = [
    { type: Component, args: [{
                selector: 'm-button',
                template: "<div class=\"pointer c-button\" [ngClass]=\"{'disabled': disabled}\" (click)=\"onClickEmit()\">\n    <i class=\"{{ icon }} c-icon\"></i>\n    <div class=\"c-label\">\n        {{ label }}\n    </div>\n</div>",
                styles: [".c-button{height:2vh;min-width:3vw;display:-webkit-box;display:flex;-webkit-box-pack:justify;justify-content:space-between;-webkit-box-align:center;align-items:center}.c-icon{width:15%;font-size:1.2em}.c-label{width:85%;text-align:end}.disabled{color:#d3d3d3}"]
            }] }
];
/** @nocollapse */
MaterialButtonComponent.ctorParameters = () => [];
MaterialButtonComponent.propDecorators = {
    label: [{ type: Input }],
    icon: [{ type: Input }],
    disabled: [{ type: Input }],
    onClick: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    MaterialButtonComponent.prototype.label;
    /** @type {?} */
    MaterialButtonComponent.prototype.icon;
    /** @type {?} */
    MaterialButtonComponent.prototype.disabled;
    /** @type {?} */
    MaterialButtonComponent.prototype.onClick;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/m-dynamic-dialog-parameter.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MDynamicDialogParameter {
}
if (false) {
    /** @type {?} */
    MDynamicDialogParameter.prototype.Component;
    /** @type {?} */
    MDynamicDialogParameter.prototype.Properties;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/m-dynamic-dialog-services/m-dynamic-dialog.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MDynamicDialogService {
    /**
     * @param {?} componentFactoryResolver
     * @param {?} applicationRef
     * @param {?} injector
     */
    constructor(componentFactoryResolver, applicationRef, injector) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.applicationRef = applicationRef;
        this.injector = injector;
    }
    /**
     * @param {?} parameter
     * @return {?}
     */
    createAndGetDialogReferenceInstance(parameter) {
        /** @type {?} */
        let reference = new MDynamicDialogReference();
        this.generateBaseDialog(reference, parameter);
        return reference;
    }
    /**
     * @return {?}
     */
    checkIfDialogContExist() {
        /** @type {?} */
        var container = document.getElementById("m-dynamic-dialog-container");
        return container != null;
    }
    /**
     * @param {?} reference
     * @param {?} parameter
     * @return {?}
     */
    generateBaseDialog(reference, parameter) {
        if (!this.checkIfDialogContExist()) {
            this.generateDialogContainer();
        }
        /** @type {?} */
        var injectorCustom = Injector.create([
            {
                provide: MDynamicDialogReference,
                useValue: reference
            }
        ]);
        /** @type {?} */
        var dialogFactory = this.componentFactoryResolver.resolveComponentFactory(MDynamicDialogComponent).create(injectorCustom);
        dialogFactory.instance.setComponentBuilders(this.componentFactoryResolver);
        dialogFactory.instance.parameter = parameter;
        dialogFactory.instance.mDynamicDialogData = this.generateDialogData(parameter.Properties.data);
        this.applicationRef.attachView(dialogFactory.hostView);
        /** @type {?} */
        const dialog = (/** @type {?} */ (((/** @type {?} */ (dialogFactory.hostView))).rootNodes[0]));
        dialog.id = reference.dialogId;
        /** @type {?} */
        let dialogContainer = document.getElementById("m-dynamic-dialog-container");
        dialogContainer.append(dialog);
        this.applicationRef.tick();
    }
    /**
     * @return {?}
     */
    generateDialogContainer() {
        /** @type {?} */
        var dialogContainer = document.createElement("div");
        dialogContainer.id = "m-dynamic-dialog-container";
        dialogContainer.style.height = "100%";
        dialogContainer.style.width = "100%";
        dialogContainer.style.position = "absolute !important";
        dialogContainer.style.background = "background: rgba(0, 0, 0, 0.5); !important";
        document.body.insertBefore(dialogContainer, document.body.firstChild);
    }
    /**
     * @param {?} data
     * @return {?}
     */
    generateDialogData(data) {
        /** @type {?} */
        let dialogData = new MDynamicDialogData();
        dialogData.data = data;
        return dialogData;
    }
    /**
     * @param {?} component
     * @param {?} properties
     * @return {?}
     */
    open(component, properties) {
        /** @type {?} */
        let parameter = new MDynamicDialogParameter();
        parameter.Component = component;
        parameter.Properties = properties;
        return this.createAndGetDialogReferenceInstance(parameter);
    }
}
MDynamicDialogService.decorators = [
    { type: Injectable, args: [{
                providedIn: "root"
            },] }
];
/** @nocollapse */
MDynamicDialogService.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: ApplicationRef },
    { type: Injector }
];
/** @nocollapse */ MDynamicDialogService.ngInjectableDef = ɵɵdefineInjectable({ factory: function MDynamicDialogService_Factory() { return new MDynamicDialogService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR)); }, token: MDynamicDialogService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    MDynamicDialogService.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    MDynamicDialogService.prototype.applicationRef;
    /**
     * @type {?}
     * @private
     */
    MDynamicDialogService.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/m-dynamic-dialog.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MDynamicDialogModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: MDynamicDialogModule,
            providers: [MDynamicDialogService, MDynamicDialogReference, MDynamicDialogData, MDynamicDialogParameter]
        };
    }
}
MDynamicDialogModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    MDynamicDialogBodyComponent,
                    MDynamicDialogComponent,
                    MaterialButtonComponent
                ],
                imports: [
                    CommonModule,
                ],
                entryComponents: [
                    MDynamicDialogBodyComponent,
                    MDynamicDialogComponent
                ],
                exports: [
                    MDynamicDialogBodyComponent,
                    MaterialButtonComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/m-dynamic-dialog-properties.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MDynamicDialogProperties {
}
if (false) {
    /** @type {?} */
    MDynamicDialogProperties.prototype.title;
    /** @type {?} */
    MDynamicDialogProperties.prototype.height;
    /** @type {?} */
    MDynamicDialogProperties.prototype.width;
    /** @type {?} */
    MDynamicDialogProperties.prototype.headerHeight;
    /** @type {?} */
    MDynamicDialogProperties.prototype.footerHeight;
    /** @type {?} */
    MDynamicDialogProperties.prototype.showHeader;
    /** @type {?} */
    MDynamicDialogProperties.prototype.showFooter;
    /** @type {?} */
    MDynamicDialogProperties.prototype.showSaveButton;
    /** @type {?} */
    MDynamicDialogProperties.prototype.saveButtonLabel;
    /** @type {?} */
    MDynamicDialogProperties.prototype.showCloseButton;
    /** @type {?} */
    MDynamicDialogProperties.prototype.closeButtonLabel;
    /** @type {?} */
    MDynamicDialogProperties.prototype.data;
    /** @type {?} */
    MDynamicDialogProperties.prototype.closeOutside;
    /** @type {?} */
    MDynamicDialogProperties.prototype.asModal;
}

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: m-dynamic-dialog.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MDynamicDialogBodyComponent, MDynamicDialogComponent, MDynamicDialogData, MDynamicDialogModule, MDynamicDialogParameter, MDynamicDialogProperties, MDynamicDialogReference, MDynamicDialogService, MaterialButtonComponent };
//# sourceMappingURL=m-dynamic-dialog.js.map
